# PaddleRS

PaddleRS是基于飞桨的遥感影像处理平台，支持遥感图像分类，目标检测，图像分割，以及变化检测等常用遥感任务。

### 遥感数据处理
- [ ] 多光谱、高光谱、SAR、无人机RGBD
- [ ] 数据切分、合并、通道提取等功能
- [ ] 支持任意通道数据增强策略
- [ ] 支持多种遥感影像格式  
  - 遥感影像的格式多种多样，不同传感器产生的数据格式也可能不同。PaddleRS现已兼容6+种格式图片读取：`tif`, `png`, `jpeg`, `bmp`, `img`, `npy`.
  - geojson格式的分割标签数据.

### 算法模型
- [ ] 分类（ResNet，MobileNet，HRNet）
- [ ] 检测（PP-YOLO，Faster-RCNN，S2ANet）
- [ ] 分割（DeepLabV3P、OCRNet、UNet）
- [ ] 变化检测（TBD）
- [ ] 特有遥感模型（FarSeg）

### 工具箱
- [ ] 数据分块
- [ ] 滑框分割/变化检测
- [ ] 栅格raster转矢量shp

### Benchmark
- [ ] 实现repo模型，至少持平往期遥感比赛精度

### 高精度预训练模型
- [ ] 构建各场景的预训练模型，如建筑物、河流、植被等

### 应用示例
- [ ] 场景范例库，指导用户完成模型的构建，完成模型落地
